/* 
 *  myauth_config.c
 *
 *  Copyright (C) Svein Olav Bjerkeset, 2012
 *  License: GNU GENERAL PUBLIC LICENSE Version 3
 */


#include "myauth_config.h"


const char* myauth_set_slot (cmd_parms *parms, void *mconfig, const char *arg)
{
	char **addr = mconfig + (long)parms->info;

	*addr = apr_pstrdup(parms->pool, arg);
	return NULL;
}


const char* myauth_set_port (cmd_parms *parms, void *mconfig, const char *arg)
{
	myauth_config_rec *cfg = (myauth_config_rec *)mconfig;
	cfg->my_port = (unsigned) atoi (arg);
	return NULL;
}


const char* myauth_set_enctype (cmd_parms *parms, void *mconfig, 
	const char *word1, const char *word2)
{
	myauth_config_rec *cfg = (myauth_config_rec *)mconfig;
	const char *arg[] = {word1, word2, NULL};
	int i;
	
	cfg->my_enctype = 0;
	for (i=0; arg[i]; i++) {
		if (strcasecmp (arg[i], "PlainText") == 0)
			cfg->my_enctype |= MYAUTH_ENC_PLAIN;
		if (strcasecmp (arg[i], "Plain") == 0)
			cfg->my_enctype |= MYAUTH_ENC_PLAIN;
		if (strcasecmp (arg[i], "Crypt") == 0)
			cfg->my_enctype |= MYAUTH_ENC_CRYPT;
		if (strcasecmp (arg[i], "MySQL") == 0)
			cfg->my_enctype |= MYAUTH_ENC_MYSQL;
		if (strcasecmp (arg[i], "MD5Base64") == 0)
			cfg->my_enctype |= MYAUTH_ENC_MD5BASE64;
		if (strcasecmp (arg[i], "All") == 0)
			cfg->my_enctype |= ( 
				MYAUTH_ENC_PLAIN | MYAUTH_ENC_CRYPT | MYAUTH_ENC_MYSQL | MYAUTH_ENC_MD5BASE64 );
	}
	return NULL;
}
